//  Copyright (c) 2019 STE||AR Group
//
//  SPDX-License-Identifier: BSL-1.0
//  Distributed under the Boost Software License, Version 1.0. (See accompanying
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

// Do not edit this file! It has been generated by the cmake configuration step.

#if !defined(HPX_CONFIG_DEFINES_STRINGS_MODULES_HPP)
#define HPX_CONFIG_DEFINES_STRINGS_MODULES_HPP

#include <hpx/affinity/config/config_strings.hpp>
#include <hpx/algorithms/config/config_strings.hpp>
#include <hpx/allocator_support/config/config_strings.hpp>
#include <hpx/assertion/config/config_strings.hpp>
#include <hpx/basic_execution/config/config_strings.hpp>
#include <hpx/batch_environments/config/config_strings.hpp>
#include <hpx/cache/config/config_strings.hpp>
#include <hpx/checkpoint/config/config_strings.hpp>
#include <hpx/collectives/config/config_strings.hpp>
#include <hpx/compute/config/config_strings.hpp>
#include <hpx/compute_cuda/config/config_strings.hpp>
#include <hpx/concepts/config/config_strings.hpp>
#include <hpx/concurrency/config/config_strings.hpp>
#include <hpx/config/config/config_strings.hpp>
#include <hpx/coroutines/config/config_strings.hpp>
#include <hpx/datastructures/config/config_strings.hpp>
#include <hpx/debugging/config/config_strings.hpp>
#include <hpx/errors/config/config_strings.hpp>
#include <hpx/execution/config/config_strings.hpp>
#include <hpx/filesystem/config/config_strings.hpp>
#include <hpx/format/config/config_strings.hpp>
#include <hpx/functional/config/config_strings.hpp>
#include <hpx/hardware/config/config_strings.hpp>
#include <hpx/hashing/config/config_strings.hpp>
#include <hpx/iterator_support/config/config_strings.hpp>
#include <hpx/local_lcos/config/config_strings.hpp>
#include <hpx/logging/config/config_strings.hpp>
#include <hpx/memory/config/config_strings.hpp>
#include <hpx/plugin/config/config_strings.hpp>
#include <hpx/preprocessor/config/config_strings.hpp>
#include <hpx/program_options/config/config_strings.hpp>
#include <hpx/resiliency/config/config_strings.hpp>
#include <hpx/resource_partitioner/config/config_strings.hpp>
#include <hpx/segmented_algorithms/config/config_strings.hpp>
#include <hpx/serialization/config/config_strings.hpp>
#include <hpx/static_reinit/config/config_strings.hpp>
#include <hpx/statistics/config/config_strings.hpp>
#include <hpx/synchronization/config/config_strings.hpp>
#include <hpx/testing/config/config_strings.hpp>
#include <hpx/thread_support/config/config_strings.hpp>
#include <hpx/threadmanager/config/config_strings.hpp>
#include <hpx/timing/config/config_strings.hpp>
#include <hpx/topology/config/config_strings.hpp>
#include <hpx/type_support/config/config_strings.hpp>
#include <hpx/util/config/config_strings.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace hpx {

    struct module_config_strings
    {
        char const* const name;
        char const* const* config_strings;
    };

    module_config_strings const config_strings_modules[] =
    {
        { "affinity", affinity::config_strings },
        { "algorithms", algorithms::config_strings },
        { "allocator_support", allocator_support::config_strings },
        { "assertion", assertion::config_strings },
        { "basic_execution", basic_execution::config_strings },
        { "batch_environments", batch_environments::config_strings },
        { "cache", cache::config_strings },
        { "checkpoint", checkpoint::config_strings },
        { "collectives", collectives::config_strings },
        { "compute", compute::config_strings },
        { "compute_cuda", compute_cuda::config_strings },
        { "concepts", concepts::config_strings },
        { "concurrency", concurrency::config_strings },
        { "config", config::config_strings },
        { "coroutines", coroutines::config_strings },
        { "datastructures", datastructures::config_strings },
        { "debugging", debugging::config_strings },
        { "errors", errors::config_strings },
        { "execution", execution::config_strings },
        { "filesystem", filesystem::config_strings },
        { "format", format::config_strings },
        { "functional", functional::config_strings },
        { "hardware", hardware::config_strings },
        { "hashing", hashing::config_strings },
        { "iterator_support", iterator_support::config_strings },
        { "local_lcos", local_lcos::config_strings },
        { "logging", logging::config_strings },
        { "memory", memory::config_strings },
        { "plugin", plugin::config_strings },
        { "preprocessor", preprocessor::config_strings },
        { "program_options", program_options::config_strings },
        { "resiliency", resiliency::config_strings },
        { "resource_partitioner", resource_partitioner::config_strings },
        { "segmented_algorithms", segmented_algorithms::config_strings },
        { "serialization", serialization::config_strings },
        { "static_reinit", static_reinit::config_strings },
        { "statistics", statistics::config_strings },
        { "synchronization", synchronization::config_strings },
        { "testing", testing::config_strings },
        { "thread_support", thread_support::config_strings },
        { "threadmanager", threadmanager::config_strings },
        { "timing", timing::config_strings },
        { "topology", topology::config_strings },
        { "type_support", type_support::config_strings },
        { "util", util::config_strings },
        { nullptr, nullptr }
    };
}

#endif
